
local io = bd.baseio

local function unlink()
   if _G.adir then
      _G.adir:unlink()
      _G.adir=nil
   end
   return false
end

local emsg

local function dirfunc(_ENV,path)
   if not response:initial() then return false end
   if #path ~= 0 then
      if not path:find"/$" and not path:find".lsp$" and not path:find".html$" then
         return false
      end
   end
   if not emsg then
      local fp=io:open"assertresp.txt"
      if not fp then return unlink() end
      emsg=fp:read"*a"
      fp:close()
      io:remove"assertresp.txt"
   end
   response:setstatus(503)
   title="FuguHub Fatal Error Report"
   response:include"/rtl/.EmptyHeader.lsp"
   response:write'<p style="font-size:140%">The server has recovered from a fatal error. The error message was sent to FuguHub.com, which responded with the following message: '
   response:write(emsg,'.</p>')
   response:include"/rtl/.EmptyFooter.lsp"
end


adir = ba.create.dir(nil,127)
adir:setfunc(dirfunc)
adir:insert()
