<?lsp
local fmt=string.format
local headercontent
if not page.autumn or cmsIsAdmin then
   local f = app.cmsdocs.open("autumn.txt", "rb")
   if f then
      page.autumn=f:read"*a"
      headercontent=page.autumn
      f:close();
   elseif cmsIsAdmin then
      headercontent="<span id='subtitle'>Create autumn.txt in your  cmsdocs directory</span>"
   else
      headercontent=""
   end
else
   headercontent=page.autumn
end


local function toHref(name,uri)
   return fmt("<a href='%s'>%s</a>\n",uri,name)
end

local function emitBlogLinks()
   local header="<div class='leftcolbox'><div class='leftcolboxtop'></div>"
   local footer = "</div>"
   if app.cats then
      if page.cats ~= app.cats then -- If categories updated
         page.cats = app.cats
         local t={}
         local uris=app.cats.uris
         for k,v in ipairs(app.cats.names) do
            table.insert(t, toHref(v, uris[k]))
         end
         page.catlinks=fmt("<div class='archives' id='archives'><h3 class='negative'>Categories</h3><pre>%s</pre><br/></div>",table.concat(t))
      end
      write(header,page.catlinks,footer)
   end
   if page.archList ~= app.archList then -- If archive list updated
      page.archList = app.archList
      local t={}
      local month=cmsMonth
      for _,year in ipairs(app.archList) do
         local y = year.y
         table.insert(t,toHref(fmt("<b class='negative'>%s</b>",y),"/blog/"..y))
         for _,m in ipairs(year.m) do
            table.insert(t,toHref(month(m),fmt("/blog/%s/%s",y,m)))
         end
      end
      page.arch=fmt("<div class='archives' id='archives'><h3 class='negative'>Archives</h3><pre>%s</pre><br/></div>",table.concat(t))
   end
   write(header,page.arch,footer)
end

local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<div id='blogh'><h1><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></h1><p>",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p></div>",
                        data,
                        "<p>",
                        pi and pi or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         write"<div id='bloge'></div>"
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      cmsEmitPage()
   end
end


local moreLinks
local subLinkName
local subLinks
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?lsp=cmsTitle?></title>
<link rel="stylesheet" type="text/css" href="/theme/autumn.css" />
<?lsp=cmsHeader?>
</head>
<body>
<div id="container"> <!-- container div contains all the content divs -->
<div id="navarea"><!-- Div containing the main navigation -->
<ul id="nav">
<?lsp
do
   local uriN=0
   local curURI=request:uri()
   local names=app.links.names
   for k,v in ipairs(app.links.uris) do
      local url
      if type(v) == "string" then
         url=v
      else
         url=v.ut[1]
         if not subLinkName then
            local found
            for _,u in pairs(v.ut) do
               if curURI == u then
                  found=true
                  break
               end
            end
            if found then
               subLinkName=names[k]
               subLinks={}
               local n=v.nt
               for k,v in pairs(v.ut) do
                  -- Stop at sub menu level 2
                  if type(v) == "string" then
                     table.insert(subLinks,fmt("<a href='%s'>%s</a>",v,n[k]))
                  end
               end
            end
         end
      end
      if url then
         local lnk=fmt("<a href='%s'>%s</a>",url,names[k])
         if uriN > 3 then
            if not moreLinks then moreLinks = {} end
            table.insert(moreLinks,lnk)
         else
            write("<li>",lnk,"</li>")
         end
         uriN = uriN + 1
      end
   end
end
?>
</ul> <!-- menu area -->
</div> <!-- End of navarea -->
<div id="hdr"><?lsp=headercontent?></div>
<div id="lftcol"> <!-- left column -->
<?lsp if cmsShowAdmLinks then ?>
<div class='leftcolbox'><div class='leftcolboxtop'></div><h3>Edit:</h3>
<div style="padding-left:3em"><div id="cmsManage"></div></div>
</div>
<?lsp end ?>
<?lsp
if moreLinks then
   response:write("<div class='leftcolbox'><div class='leftcolboxtop'></div><h3>links</h3><p>",
                  table.concat(moreLinks, "<br/>"),
                  "</p></div>")
end
if subLinks then
   response:write("<div class='leftcolbox'><div class='leftcolboxtop'></div><h3>",
                  subLinkName,
                  "</h3><p>",
                  table.concat(subLinks, "<br/>"),
                  "</p></div>")
end
if cmsIsBlog then
   emitBlogLinks()
end
?>
</div><!-- end of left column -->
<div id="maincol"><div id="InnerContent">
<?lsp 
if cmsRssUri then
   write("<a id='feedurl' href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='border:none'/></a>")
end
emitContent()
?>
</div></div>

<div id="bttmbar"> <!-- Bottom bar for copyright and bottom navigation -->
<?lsp
if cmsIsAdmin then
   print[[<a href="/private/manage/" title="Configure the CMS">Configure</a>]]
end
?>
</div>


</div> <!-- end of container div -->

<div id="rtlinfo">
<p>FuguHub is powered by the <a target="rtl" href="http://realtimelogic.com/products/barracuda-application-server/">Barracuda Application Server</a> and the <a target="rtl" href="http://realtimelogic.com/products/sharkssl/">SharkSSL Embedded SSL Stack</a></p>
</div>


<?lsp cmsEmitGA() ?>
</body>
</html>
