<?lsp
local fmt=string.format

local headercontent
if not page.zenlike or cmsIsAdmin then
   local f = app.cmsdocs.open("zenlike.txt", "rb")
   if f then
      page.zenlike=f:read"*a"
      headercontent=page.zenlike
      f:close();
   elseif cmsIsAdmin then
      headercontent="<p>Create zenlike.txt in your cmsdocs directory</p>"
   else
      headercontent=""
   end
else
   headercontent=page.zenlike
end


local function toHref(name,uri)
   return fmt("<a href='%s'>%s</a>\n",uri,name)
end


local function emitBlogLinks()
   if app.cats then
      if page.cats ~= app.cats then -- If categories updated
         page.cats = app.cats
         local t={}
         local uris=app.cats.uris
         for k,v in ipairs(app.cats.names) do
            table.insert(t, toHref(v, uris[k]))
         end
         page.catlinks=fmt("<div class='archives' id='archives'><h3 class='negative'>Categories</h3><pre>%s</pre></div>",table.concat(t))
      end
      print(page.catlinks)
   end
   print("<div class='archives' id='archives'><h3 class='negative'>Archives</h3><pre>")
   if page.archList ~= app.archList then -- If archive list updated
      page.archList = app.archList
      local t={}
      local month=cmsMonth
      for _,year in ipairs(app.archList) do
         local y = year.y
         table.insert(t,toHref(fmt("<b class='negative'>%s</b>",y),"/blog/"..y))
         for _,m in ipairs(year.m) do
            table.insert(t,toHref(month(m),fmt("/blog/%s/%s",y,m)))
         end
      end
      page.arch=table.concat(t)
   end
   write(page.arch,"</pre></div>")
   
end

local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<div id='blogh'><h1><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></h1><p>",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p></div>",
                        data,
                        "<p>",
                        pi and pi or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         write"<div id='bloge'></div>"
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      cmsEmitPage()
   end
end


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?lsp=cmsTitle?></title>
<link rel="stylesheet" type="text/css" href="/theme/zenlike.css" />
<?lsp=cmsHeader?>
</head>
<body>
<div id="upbg"></div>
<div id="outer">
<div id="header">
<div id="headercontent"><?lsp=headercontent?></div>
</div>
<div id="headerpic"></div>
<div id="menu">
<ul>
<?lsp


local moreLinks
local subLinkName
local subLinks
do
   local uriN=0
   local curURI=request:uri()
   local names=app.links.names
   for k,v in ipairs(app.links.uris) do
      local url
      local found
      if type(v) == "string" then
         url=v
      else
         url=v.ut[1]
         if not subLinkName then
            for _,u in pairs(v.ut) do
               if curURI == u then
                  found=true
                  break
               end
            end
            if found then
               subLinkName=names[k]
               subLinks={}
               local n=v.nt
               for k,v in pairs(v.ut) do
                  -- Stop at sub menu level 2
                  if type(v) == "string" then
                     table.insert(subLinks,fmt("<a href='%s'>%s</a>",v,n[k]))
                  end
               end
            end
         end
      end
      if url then
         local lnk=fmt("<a href='%s'>%s</a>",url,names[k])
         if uriN > 6 then
            if not moreLinks then moreLinks = {} end
            table.insert(moreLinks,lnk)
         else
            if found or url == curURI then
               write("<li class='active'>",lnk,"</li>")
            else
               write("<li>",lnk,"</li>")
            end
         end
         uriN = uriN + 1
      end
   end
end
?>
</ul>
</div>
<div id="menubottom"></div>


<div id="content">
<?lsp if cmsIsBlog or moreLinks then ?>
<div id="primarycontainer">
<div id="primarycontent">
<div id="InnerContent">
<?lsp emitContent() ?>
</div>
</div>
</div>
<div id="secondarycontent">
<?lsp
if moreLinks then
   print("<div class='archives'><h3 class='negative'>Links</h3><pre>")
   write(table.concat(moreLinks, "\n"),"</pre></div>")
end
if subLinks then
   response:write("<div class='archives'><h3 class='negative'>",
                  subLinkName,"</h3><pre>")
   write(table.concat(subLinks, "\n"),"</pre></div>")
end
if cmsIsBlog then
   emitBlogLinks()
end
?>
</div>
</div>
<?lsp else ?>
<div id="InnerContent">
<?lsp emitContent() ?>
</div>
<?lsp end ?>

<div id="footer">
<table><tr><td>
<?lsp
if cmsRssUri then
   write("<a id='feedurl' href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='border:none'/></a>")
end
if cmsIsAdmin then
   if cmsShowAdmLinks then
      print"<div id='cmsManage'></div>"
   end
   print"<a href='/private/manage/' title='Configure Application'>Configure</a>"
end
?>
</td>
<td class="right">
FuguHub includes: 
<a target="rtl" href="http://FuguHub.com/MxTunnel.lsp">SSL VPN</a>,
<a target="rtl" href="http://realtimelogic.com/products/barracuda-application-server/">Embedded Web Server</a>,
<a target="rtl" href="http://FuguHub.com/BulletinBoard.lsp">Bulletin Board</a>,
<a target="rtl" href="http://FuguHub.com/cms.lsp">CMS</a>,
<a target="rtl" href="http://FuguHub.com/blog.lsp">Blog Engine</a>,
<br/>
<a target="rtl" href="http://FuguHub.com/database.lsp">SQLite Database</a>,
<a target="rtl" href="http://FuguHub.com/FileServer.lsp">WebDAV Server</a>, and more.
Design by <a href="http://www.nodethirtythree.com/">NodeThirtyThree Design</a>
</td></tr></table>
</div>
</div>
<?lsp cmsEmitGA() ?>
</body>
</html>
