<?lsp

local trim=bd.trim


local data = request:data()
if  not data.name  or not data.email or not data.message then
  response:sendredirect("/")
  return
end

data.name,data.email,data.message = bd.xssfilter(data.name),bd.xssfilter(data.email),bd.xssfilter(data.message)


-- If SPAM check is on
local function isCorrectAnswer()
   if data.A and data.R then
      if ba.aesdecode(app.spamctrl.aeskey, data.R) == trim(data.A) then
         return true
      end
   end
   return false
end

local function appendMessage()
   data.message = data.message:gsub('\n','<br/>')
   if conn then
      local url = request:header("referer")
      if not url then url="" end
      conn:execute(string.format(
        "insert into feedback (date, name, email, message, ipaddr, url) values ('%u', '%s', '%s', '%s', '%s', '%s')",
        time and time or os.time(),
        data.name:gsub("'","''"),
        data.email:gsub("'","''"),
        data.message:gsub("'","''"),
        request:peername(),
        url))
   end
end

local function pageActionOK()
   appendMessage()
   local str=[[
<h1>Thank you</h1>
<p><b>The following message was accepted:</b></p>
]]
  response:write(str,data.message)

  local r = request:header("referer")
  if r then
     pfmt([[<p><br/></p><p><a href="%s">Continue</a></p>]],r)
  end
end


local function pageActionWrongKeys()
   local str=[[
<h1>Illegal Submit</h1>
<p><b>You have triggered the spam prevention logic. You may get this message if you are using too long of a time to write the message or if your browser does not properly support JavaScript.</b></p>
]]
  response:write(str)
end


local function pageActionError()
   local str=[[
<h1>No Name or Message</h1>
<p><b>Press the back button and enter a message.</b></p>
]]
  response:write(str)
end

local function pageActionNoHtml()
   local str=[[
<h1>HTML in message is not allowed</h1>
<p><b>Press the back button and remove HTML formatting from the message.</b></p>]]
  response:write(str)
end

local function wrongAnswer()
   local str=[[
<h1>Wrong Answer</h1>
<p><b>Press the back button and remove HTML formatting from the message.</b></p>]]
  response:write(str)
end


-- Check that the keys match the encrypted keys and that the time
-- difference is no more than one hour. The keys are generated in
-- feedbackform.lsp
local function checkKeys()
   if data.k1 and data.k2 and data.ck1 and data.ck2 and
      data.k1 == ba.aesdecode(app.spamctrl.aeskey, data.ck1) and
      data.k2 == ba.aesdecode(app.spamctrl.aeskey, data.ck2)
   then
      local now = os.time()
      local t = tonumber(data.k1) -- k1 is the time when form was loaded
      local oneH = 60*60 -- One hour slack
      if t < now and t+oneH > now then
         return true
      end
   end
   return false
end


data.name = trim(data.name)
data.message = trim(data.message)
local lmsg=string.lower(data.message)

if not checkKeys() then
   cmsEmitPage = pageActionWrongKeys
elseif #data.name == 0 or #data.message == 0 then
   cmsEmitPage = pageActionError
elseif string.find(lmsg, "<.+>.*<%s*/") or
   string.find(lmsg, "<%s*a%s+href") or
   string.find(lmsg, "url%s*=%s*http") then
   cmsEmitPage = pageActionNoHtml
elseif app.cfg.SpamPrev and not isCorrectAnswer() then
   cmsEmitPage = wrongAnswer
else
   cmsEmitPage = pageActionOK
end

function cmsMonth() return "" end


env,conn = app.openDb()
cmsTitle="Feedback"
response:forward(".layout.lsp", true)
app.closeDb(env,conn)
?>
