<?lsp

local fmt = string.format
local function pfmt(...)
   response:write(fmt(...))
end

local function emitChecked(attr, val)
   if attr==val then
      print("checked")
   end
end

if request:method() == "POST" then
   local d = bd.xssfilter(bd.trim(request:data()))
   local cfg={}
   cfg.IsPublic = d.IsPublic == "true" and "true" or "false"
   cfg.SpamPrev = d.SpamPrev and "true" or "false"
   cfg.ssl = d.ssl and "true" or "false"
   cfg.ShowLogin = d.ShowLogin and "true" or "false"
   cfg.GoogleAnalytics = d.GoogleAnalytics
   cfg.theme = d.theme
   cfg.blog = d.blog
   cfg.msgrsskey = d.msgrsskey
   cfg.bloggeruser = d.bloggeruser
   cfg.bloggerpasswd = d.bloggerpasswd
   cfg.fbkey = d.fbkey
   cfg.fblink = d.fblink


   env,conn = app.openDb()
   local exec={}
   if env then
      for k,v in pairs(cfg) do
         table.insert(exec,fmt("UPDATE config SET key='%s',value='%s' WHERE key='%s'",k,v:gsub("'","''"),k))
      end
      local ok,resp,err=conn:mexec(table.concat(exec, ";"))
      if not ok then trace(resp, err) end
      app.closeDb(env,conn)
      app.configUpdated()
   end
end
local cfg = app.config

local bio = bd.baseio
local themes={}
for name,isdir in bio:files("themes", true) do
   if isdir then
      if bio:stat(fmt("themes/%s/.layout.lsp",name)) then
         table.insert(themes, name)
      end
   elseif string.match(name,"%.zip$") then
      name=string.gsub(name, "%.zip$","")
      table.insert(themes, name)
   end
   table.sort(themes)
end


-- The extra header we need ".header" to add.
headerdata=[[
<script type="text/javascript" src="configure.js"></script>
<script type="text/javascript">
$(function() {
   var s = $("#msgrsskey").val()
   $("#msgrsskeyhlp").click(function() {
      if(!s.length) alert("Please enter a key and click save before clicking the button.");
      else window.location="/messages.lsp?key="+s;
   });
});
</script>
]]
title="CMS: Configure"
response:include".header.lsp"

?>
<div id="help"></div>
<h1>Configure CMS</h1>


<div id="config" class="manage" style="width:350px">
<form method="post">
  <table style="width:100%">
   <tr>
     <td>Public CMS</td>
     <td><input type="radio" name="IsPublic" value="true" <?lsp emitChecked(cfg.IsPublic,"true") ?>/></td>
     <td><img hlp='IsPublic' src='btn/questionmark.16.gif' alt=''/></td>
   </tr>
   <tr>
     <td>Private CMS</td>
     <td><input type="radio" name="IsPublic" value="false" <?lsp emitChecked(cfg.IsPublic,"false") ?> /></td>
     <td></td>
   </tr>
   <tr>
     <td>Response Spam block</td>
     <td><input type="checkbox" id="SpamPrev" name="SpamPrev" <?lsp emitChecked(cfg.SpamPrev,"true") ?> /></td>
     <td><img hlp='SpamPrev' src='btn/questionmark.16.gif' alt=''/></td>
   </tr>
   <tr>
     <td>Secure connection</td>
     <td><input type="checkbox" id="ssl" name="ssl" <?lsp emitChecked(cfg.ssl,"true") ?> /></td>
     <td><img hlp='ssl' src='btn/questionmark.16.gif' alt=''/></td>
   </tr>
   <tr>
     <td>Show login form</td>
     <td><input type="checkbox" id="ShowLogin" name="ShowLogin" <?lsp emitChecked(cfg.ShowLogin,"true") ?> /></td>
     <td><img hlp='ShowLogin' src='btn/questionmark.16.gif' alt=''/></td>
    </tr>
    <tr>
      <td>Google Analytics ID</td>
      <td><input type="text" id="GoogleAnalytics" name="GoogleAnalytics" value="<?lsp=cfg.GoogleAnalytics?>" /></td>
      <td><a href='http://www.google.com/support/analytics/bin/answer.py?answer=66983' target='_blank'><img style="border:none" hlp='GoogleAnalytics' src='btn/questionmark.16.gif' alt=''/></a></td>
    </tr>
    <tr>
      <td>Theme</td>
      <td>
        <select name="theme">
          <?lsp
            for _,theme in ipairs(themes) do
               pfmt("<option value='%s' %s>%s</option>",theme, theme == cfg.theme and "selected" or "", theme) 
            end
          ?>
        </select>
        </td><td><img hlp='theme' src='btn/questionmark.16.gif' alt=''/></td>
    </tr>
    <tr>
      <td>Blog menu name</td>
      <td><input type="text" name="blog" value="<?lsp=cfg.blog?>" /></td>
      <td><img hlp='blog' src='btn/questionmark.16.gif' alt=''/></td>
    </tr>
    <tr>
      <td>Messages RSS key</td>
      <td><input id="msgrsskey" type="text" name="msgrsskey" value="<?lsp=cfg.msgrsskey?>" /></td>
      <td><img id='msgrsskeyhlp' noclick="true" hlp='msgrsskey' src='btn/questionmark.16.gif' alt=''/></td>
    </tr>
  </table>

  <fieldset>
    <legend>MetaWeblog</legend>
    <table style="width:100%">
      <tr>
        <td>Username </td>
        <td><input type="text" name="bloggeruser" value="<?lsp=cfg.bloggeruser?>"/></td>
        <td rowspan="2"><img hlp='MetaWeblog' src='btn/questionmark.16.gif' alt='help'/></td>
      </tr>
      <tr>
        <td>Password </td>
        <td><input type="text" name="bloggerpasswd" value="<?lsp=cfg.bloggerpasswd?>"/></td>
      </tr>
    </table>
  </fieldset>
<!--
  <fieldset>
    <legend>Facebook</legend>
    <table style="width:100%">
      <tr>
        <td>API Key </td>
        <td><input type="text" name="fbkey" value="<?lsp=cfg.fbkey?>"/></td>
        <td rowspan="2"><img hlp='facebook' src='btn/questionmark.16.gif' alt='help'/></td>
      </tr>
      <tr>
        <td>Link Name </td>
        <td><input type="text" name="fblink" value="<?lsp=cfg.fblink?>"/></td>
      </tr>
    </table>
  </fieldset>
-->
  <p><input type="submit" value="Save"/></p>
</form>
</div>
<div id="info" class="center" style="width:400px;display:none">
</div> 

<?lsp response:include".footer.lsp" ?>
