<?lsp
local env,conn = app.openDb()

local fmt=string.format
local function pfmt(...)
   response:write(fmt(...))
end

-- The extra header we need ".header" to add.
headerdata=[[
<link href="/rtl/fstab.css" rel="stylesheet" type="text/css" />
<script type='text/javascript' src='/rtl/wfm/wfm.js'></script>
<script type="text/javascript">
window.sortList=[ [0,1] ];
  $(function(){initHelp("messages");});
</script>
]]
title="CMS: Messages"
response:include".header.lsp"

?>

<div id="help"></div>
<img hlp='intro' src='btn/questionmark.32.gif' alt='Help' style='float:right;margin:.5em 3em 0 0;border:none'/>
<?lsp
local data = request:data()
if data.key then
   if request:method() == "POST" then
      local na,e=conn:execute(fmt('DELETE FROM feedback WHERE  k=%s',data.key),1000)
      response:sendredirect("")
      return
   end
   local cur = conn:execute(
     fmt('SELECT DISTINCT date, name, email, message, ipaddr, url FROM feedback WHERE k=%s',data.key))
   if not cur then
      response:senderror(404)
      return
   end
   local date, name, email, message, ipaddr, url=cur:fetch()
   cur:close();
   if not date then
      response:senderror(404)
      return
   else
?>
<script>
function showIpInfo()
{
  var src = "http://api.hostip.info/get_html.php?position=true&ip=<?lsp=ipaddr?>";
  $("#loinfo").attr("src",src).show();
};
</script>
<div class="manage" style="width:550px">
<h1>Message #<?lsp=data.key?></h1>
<div id="<?lsp=data.key and 'tab' or 'fstab'?>">
<table width="100%%">
<?lsp
      print(fmt([[
<tr><td><b>Name:</b></td><td>%s</td></tr>
<tr><td><b>Email:</b></td><td><a href="mailto:%s">%s</a></td></tr>
<tr><td>
<b>IP Address:</b></td>
<td>
<a href="#" onclick="return showIpInfo();">%s</a>
<iframe frameborder="0" style="width:400px;height:140px;float:right;display:none" id="loinfo"></iframe>
</td></tr>
<tr><td>
<b>Sent From:</b></td><td><a href="%s">%s</a>
</td></tr>
<tr><td><b>Date:</b></td><td>%s</td></tr>
<tr><td colspan="2" align = "center">
<form method="post">
<input type="submit" value="Delete Message" />
</form>
</td></tr>
</table>
</div>
<p><b>Message:</b></p>
%s
]],
            name,
            email,email,
            ipaddr,
            url,url,
            os.date("%c",tonumber(date)),
            message))
   end
?>
</div>
<?lsp else ?>
<script type="text/javascript">
onload=function()
{
   var isMouseOver=false;
   $("td[key]").mouseover(function(e){
      isMouseOver=true;
      var y;
      if(e.pageY > 400) y = e.pageY - 350;
      else if(e.pageY > 300) y = e.pageY - 250;
      else if(e.pageY > 200) y = e.pageY - 150;
      else if(e.pageY > 100) y = e.pageY - 50;
      else y = e.pageY+50;
      $("#popupm").css("top", y+"px");
      $("#popupc").load("message.lsp?key="+$(this).attr("key"), function() {
         if(isMouseOver)
            $("#popupm").show();
      })
   });
   $("td[key]").mouseout(function(){
      isMouseOver=false;
      $("#popupm").hide();
   });
};
</script>
<div id="popupm" style="position:absolute;width:80%;left:10px;border:solid 1px;background:white;z-index:10;display:none">
<div style="background:#F0EFE6;width:100%;text-align:center">
<b>Click the link to view the full message.</b>
</div>
<div id="popupc" style="height:300px;overflow:hidden">
</div>
</div>
<h1 class="center">Messages</h1>
<br/>
<div style="margin-left:auto; margin-right:auto;width:80%">
<div id="fstab">
<table style="width:100%;border: 1px solid"><thead>
<tr><th>Date</th><th>Name</th><th>Email</th><th>IP address</th><th>View</th></tr>
</thead><tbody>
<?lsp
local cur = conn:execute('SELECT k, date, name, email, ipaddr FROM feedback ORDER BY date DESC')
local key, date, name, email, ipaddr=cur:fetch()
   while date do
         pfmt(
           [[
<tr><td>%s</td>
<td>%s</td>
<td>%s</td>
<td>%s</td>
<td  key="%s">
<a href="messages.lsp?key=%s">
<img border="0" src="/images/file.gif" border="0" alt="view"/>
</a>
</td>
]],
      os.date("%Y-%m-%d-%H:%M",tonumber(date)),name,email,ipaddr,key,key)
      key, date, name, email, ipaddr=cur:fetch()
   end
cur:close()
?>
</tbody>
</table>
</div>
</div>
<?lsp end ?>
</body>
</html>
<?lsp 
app.closeDb(env,conn)
response:include".footer.lsp"
?>
