<?lsp

local fmt=string.format
local tinsert=table.insert
local imgName2Thumb=app.imgName2Thumb
local cms = app.getCmsTab(request:session())

local cfg
if cms.imgUplCfg then
   cfg=cms.imgUplCfg
   if not cfg.albumtitle then cfg=nil
   end
end
if not cfg then
   response:sendredirect"cfgalbum.lsp"
   return
end

local newPhotos=false;
local photos={}
local infolist={}
do
   local q=fmt([[SELECT PhotoAlbums.img,PhotoAlbums.info FROM PhotoAlbumNames,PhotoAlbums
                 WHERE PhotoAlbumNames.name="%s" AND
                 PhotoAlbumNames.key = PhotoAlbums.album
                 ORDER BY PhotoAlbums.key]], cfg.albumtitle)
   local env,conn = app.openDb()
   local cur=conn:execute(q)
   if cur then
      local img,info = cur:fetch()
      while img do
         tinsert(photos, img)
         tinsert(infolist,info)
         img,info = cur:fetch()
      end
      cur:close()
   end
   app.closeDb(env,conn)
end
if cfg.photos then
   newPhotos = #cfg.photos > 0 and true or false
   for _,img in ipairs(cfg.photos) do
      img=fmt("/%s",img):gsub("//","/")
      tinsert(photos,img)
      tinsert(infolist,"")
   end
end
if #photos == 0 then
   trace("NO PHOTOS")
   response:sendredirect"cfgalbum.lsp"
   return
end


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<title>Create Album</title>
<link href="../style.css" rel="stylesheet" type="text/css" />
<link href="../help.css" rel="stylesheet" type="text/css" />
<style type="text/css">
#photos, #info {width:400px; margin:0px auto;}
#photos {background:#F0EFE6; }
#photos table {width:100%; border:3px ridge; border-collapse:collapse;}
#photos td {border-bottom:3px ridge; padding: 3px;}
#info div {float:right;margin:10px 0 3em 0}
#info div button {padding:5px;margin-left:1em}
</style>
<script type="text/javascript" src="/rtl/jquery.js"></script>
<script type="text/javascript" src="/rtl/eh/eh.js"></script>
<script type="text/javascript" src="/rtl/json/json.js"></script> 
<script type="text/javascript" src="/rtl/json/jrpc.js"></script>
<script type="text/javascript" src="../help.js"></script>
<script type="text/javascript">
function getPos(tr) {return $("#photos tr").index(tr);}
function setDefBg(tr) {$("#photos td").css("background", "#F0EFE6");};
function getImgUrl(tr){return tr.children().eq(1).children("img").attr("src");};
$(function() {
   initHelp("images","../");
   var pos1,pos2,start,end,rpc;
   function setStartEnd() {
      if(pos2 > pos1) { end=pos2; start=pos1; }
      else { start=pos2; end=pos1; }
   };
   function clearSelect() { pos1=pos2=undefined;setDefBg(); };
   function selectRange(color) {
      setStartEnd();
      $("#photos tr").slice(start,end+1).children("td").css("background", color ? color : "yellow");
   };
   function enableEvents() {
      $("#photos .up").show().click(function() {move($(this), true); return false;});
      $("#photos .down").show().click(function() {move($(this, false));return false;});
      $("#photos .up:first").hide();
      $("#photos .down:last").hide();
      $("#photos td").click(selectEV);
      $("#photos textarea").click(function() {clearSelect(); return false;});
   }
   function selectEV(e) {
      setDefBg();
      var tr=$(this).parent();
      var pos=getPos(tr);
      if(pos1 != undefined && pos2 != undefined) {
         if(pos == pos2) {
            clearSelect();
            return;
         }
         pos1=pos2;
      }
      if(pos1 != undefined) {
         if(pos == pos1) {
            clearSelect();
            return;
         }
         pos2=pos;
      }
      else pos1=pos;
      if(pos2 != undefined) {
         selectRange(e.ctrlKey ? "red" : undefined);
         if(e.ctrlKey) tr=$("#photos tr").slice(start,end+1);
      }
      else
         tr.children("td").css("background", e.ctrlKey ? "red" : "yellow");
      if(e.ctrlKey) {
         var l=tr.length;
         var msg = "Delete ";
         if(l == 1) msg += getImgUrl(tr);
         else msg += l.toString() + " images";
         msg+="?";
         if(confirm(msg)) {
            var t=[];
            tr.each(function() {
               t[t.length]=getImgUrl($(this));
            });
            rpc.album.remove(function(ok,resp) {
               if(resp == "ok") tr.remove();
               else alert(resp);
            }, t);
         }
         clearSelect();
      }
   };
   function move(img, up) {
      var trx,slice,pos;
      var tr = img.parent().parent();
      if(pos1 != undefined && pos2 != undefined) {
         pos=getPos(tr);
         if(start <= pos && pos <= end) {
            var trs = $("#photos tr");
            setStartEnd();
            if((up && start == 0) || (!up && (end+1) == $("#photos tr").length)) {
               clearSelect();
               return;
            }
            trx=trs.slice(start,end+1);
            slice=true;
            tr = trs.eq(up?start:end);
            if(up) { pos1--; pos2--; }
            else { pos1++; pos2++; }
            setStartEnd();
         }
      }
      if(!trx) trx=tr;
      tr = up ? tr.prev() : tr.next();
      trx.remove();
      if(up) tr.before(trx);
      else tr.after(trx);
      setDefBg();
      enableEvents();
      if(slice) {
         setStartEnd();
         if(start == 0 || (end+1) == $("#photos tr").length) clearSelect();
         else selectRange();
      }
   };
   $("#info p").empty();
   $("#photos").fadeTo("fast", 1);
   var rpc = new JRpc("albumWS.lsp", function(ok,err) {
      if(ok) {
         enableEvents();
         $("#savebut").click(function() {
            var t=[];
            $("#photos tr").each(function() {
               var info=$(this).children().eq(2).children("textarea").val();
               t[t.length]={img:getImgUrl($(this)),info:info}
            });
            rpc.album.save(function(ok,resp) {
               if(resp == "ok") {
                  if(parent != window && parent.doneUploading)
                     parent.doneUploading(true);
                  else
                     window.location = "../images.lsp";
               }
               else alert(resp);
            }, t);
         });
         $("#cancelbut").click(function() {
            if(parent != window && parent.doneUploading)
               parent.doneUploading(false);
            else
               window.location="../images.lsp";
         });
      }
      else alert(err);
   });
});
</script>
</head>
<body>
<div id="help"></div>
<h1 class="center">Manage Album</h1>
<img hlp='manage' src='../btn/questionmark.32.gif' alt='Help' style='float:right;margin:0 8em 0 0;border:none'/>
<div id="photos" style="opacity:0.15;filter:alpha(opacity=15);">
<table>
<?lsp
for i,img in ipairs(photos) do
   response:write('<tr><td><img class="up" src="uparrow.png"/><br/><img class="down" src="downarrow.png"/></td><td><img src="',imgName2Thumb(img),'"</td><td>',img,'<textarea name="title" rows="3">',infolist[i],'</textarea></td></tr>')
   
end
?>
</table>
</div>
<div id="info">
<div>
<button id="savebut" type="button">Save</button>
<?lsp= newPhotos and "" or '<button id="cancelbut" type="button">Cancel</button>' ?>
</div>

</div>
</body>
</html>
