<?lsp

if not bd.db.email(request) then
   response:sendredirect"../../email.lsp"
end

local function noSmtp()
   response:include"../../../.smtp.lsp"
   if loadSmtpFromBdDb() then return false end
   return true
end
if noSmtp() then
   response:sendredirect"settings.lsp"
end

local fmt=string.format
local sqlutil=require"sqlutil"
local mailutil=require"mailutil"
local env,conn = bd.openDb"bd"

local function closeDb(uri)
   bd.closeDb(env,conn)
   env,conn=nil,nil
   if uri then
      response:sendredirect(uri)
   end
end

local function getKey(data)
   if data.key and tonumber(data.key) then
      local name=sqlutil.find(conn, fmt("name FROM maillist WHERE key=%s", data.key))
      if name then return name,data.key end
   end
   return "All Lists"
end

local data=request:data()
local listname,listkey=getKey(data)

local extsql=listkey and fmt("listkey=%s AND",listkey) or ""
local notConfirmedSize=sqlutil.find(conn, fmt("COUNT(*) FROM mailcontact WHERE %s password IS NULL", extsql))
local confirmedSize=sqlutil.find(conn, fmt("COUNT(*) FROM mailcontact WHERE %s password IS NOT NULL", extsql))


local ok,errmsg
if request:method() == "POST" then
   local data=bd.trim(request:data())
   if data.delete then
      local sql=listkey and
         fmt("DELETE FROM mailcontact WHERE listkey=%s AND password IS NULL",listkey) or
         "DELETE FROM mailcontact WHERE password IS NULL"
      mailutil.sqlexec(conn,sql)
   elseif data.send then
      local body,foundT=mailutil.expandmacros(
         data.body, {
            LINK=function (x) return x end,
         }
      )
      if foundT.LINK ~= 1 then
         if foundT.LINK then
            errmsg="The email body cannot contain more than one [LINK] macro!"
         else
            errmsg="Macro [LINK] required when sending links!"
         end
      else
         local cfg = {
            list=listkey and {listkey} or {},
            body=data.body,
            subject = #data.subject>0 and data.subject or "Confirm your Email Address",
            settings={ssl=data.ssl}
         }
         mailutil.settings(conn,"confirmpwdsec", data.ssl and "1" or "0")
         if notConfirmedSize ~= "0" then
            ok,errmsg=mailutil.startjob(request:user(),cfg)
         end
      end
   end
   if not errmsg then
      closeDb(fmt("list.lsp?name=%s&offset=%s",
                  listkey and ba.urlencode(listname) or "", data.offset or "0"))
   end
end


   headerdata=[[
<style>
textarea {width:100%;height:200px;}
#subject{width:100%;border-collapse:collapse}
input[type=submit] { min-width:100px;height:30px;}
#selaction {display:none}
p.err{font-weight:bold;color:red}
</style>
<script>
$(function() {
   $("#selaction").show();
   $("#del").hide();
   $("#selaction input").click(function() {
      if($(this).val() == "delete") {
         $("#send").hide();
         $("#del").show();
      }
      else {
         $("#del").hide();
         $("#send").show();
      }
   });
});
</script>
]]
title="Contact Confirmation"
addListTxt=title
response:include"/rtl/.header.lsp"

local function getBody()
   return data.body or [[
Hello [FIRSTNAME]

Visit the following link and set your password:
[LINK]
]]
end

?>
<div class="roundedbox">
<h1>Contact confirmation request for: <?lsp=listname?></h1>
<p class="err"><?lsp=errmsg or ""?></p>
<fieldset><legend>Statistics:</legend>
<table>
<tr><td>Passwords set and emails confirmed:</td><td><?lsp=confirmedSize?></td></tr>
<tr><td>Emails not confirmed:</td><td><?lsp=notConfirmedSize?></td></tr>
</table>
</fieldset>
<p></p>
<div id="selaction">
<input type="radio" name="action" value="email" checked="checked" />Request confirmation from all unconfirmed contacts <input type="radio" name="action" value="delete" />Delete all unconfirmed contacts 
</div>
<p></p>
<fieldset><legend>Action:</legend>
<div id="del">
<form method="post">
<p></p>
<input type="submit" name="delete" value="Delete Unconfirmed Contacts" <?lsp=notConfirmedSize == "0" and 'disabled="disabled"' or ''?>/>
<input type="submit" name="cancel" value="Cancel"/>
<input type="hidden" name="offset" value="<?lsp=data.offset or ''?>"/>
</form>
</div>
<div id="send">
<form method="post">
<p></p>
<table id="subject">
<tr><td style="width:55px;">Subject: </td><td><input style="width:100%" type="text" id="subject" name="subject" value="" placeholder="Confirm your Email Address"/></td></tr>
</table>
<textarea name="body"><?lsp=getBody()?></textarea>
<input type="checkbox" name="ssl" <?lsp
if mailutil.settings(conn,"confirmpwdsec") == "1" then response:write'checked="checked"' end
?>/> Secure Connection Required.<br/>
<input type="submit" name="send" value="Send Request" <?lsp=notConfirmedSize == "0" and 'disabled="disabled"' or ''?>/>
<input type="submit" name="cancel" value="Cancel"/>
<input type="hidden" name="offset" value="<?lsp=data.offset or ''?>"/>
</form>
</div>
</fieldset>
</div>

<?lsp
closeDb()
response:include".footer.lsp"
?>
