<?lsp

local fromaddr=bd.db.email(request)
if not fromaddr then
   response:sendredirect"../../email.lsp?lfm="
end

local mailutil=require"mailutil"

response:include"../../../.smtp.lsp"
smtp=loadSmtpFromBdDb()
if not smtp then
   smtp=loadSmtpFromCfg()
   if smtp then
      saveSmtpToBdDb(smtp)
   else
      smtp=createSmtp()
   end
end

function savesmtp(smtp)
   saveSmtpToBdDb(smtp)
end

function sendTestMail(m,smtp)
   local cfg={server=smtp.server,port=smtp.port}
   if smtp.useauth then
      cfg.user=smtp.uname
      cfg.password=smtp.password
      if smtp.consec == "tls" then
         cfg.shark=bd.getDefaultSharkClient()
      elseif smtp.consec == "starttls" then
         cfg.starttls=true
         cfg.shark=bd.getDefaultSharkClient()
      end
   end
   local mail=socket.mail(cfg)
   local cfg={
      from=smtp.email,
      replyto=fromaddr,
      to=smtp.email,
      subject=m.subject,
      body=m.body,
   }
   local ok,err=mail:send(cfg)
   if ok then
      mailutil.startjob() -- Reload settings
   end
   return ok,err
end

local data=bd.trim(request:data())
local env,conn=bd.openDb"bd"
local domainname = mailutil.settings(conn,"domainname")
local ticktime = math.floor(tonumber(mailutil.settings(conn,"ticktime")) / 1000)
if data.ticktime and data.domainname then
   ticktime=tonumber(data.ticktime) or 60
   domainname=data.domainname
   if ticktime > 600 then
      ticktime = 600
   end
   local n=string.match(domainname,"http[s]?://([^/:]+)")
   if not n then n = string.match(domainname,"([^/:]+)") end
   domainname = n or domainname
   mailutil.settings(conn,"ticktime", ticktime == 0 and 500 or ticktime*1000)
   mailutil.settings(conn,"domainname", domainname)
end

headerdata=[[
<script type="text/javascript" src="../../../smtp.js"></script>
<link href="../../../smtp.css" rel="stylesheet" type="text/css"/>
]]
title="Menu: Mail Manager: Settings"
response:include"/rtl/.header.lsp"
?>
<div class="roundedbox">
<form method="post" autocomplete="off">
<fieldset>
  <legend><b> Send Mail Settings </b></legend>
  <table>
   <tr><td><b>Domain Name:</b></td><td><input class="wide" type="text" name="domainname" value="<?lsp=domainname?>" placeholder="Enter your FuguHub server's domain name"/></td></tr>
   <tr><td><b>Send Delay:</b></td><td><input class="wide" type="text" name="ticktime" value="<?lsp=ticktime?>" placeholder="Time in seconds"/></td></tr>
  </table>
  <input type="submit" name="savebut" value="Save" />
</fieldset>
</form>
<?lsp 

emitSMTP()
_emit'</div>'
bd.closeDb(env,conn)
response:include".footer.lsp"
?>
