<?lsp

local fmt=string.format
local function getOS()
   local url='https://FuguHub.com/'
   local ua=request:header"User-Agent"
   local os="'unknown device'"
   local wh, wl = ua:match("Windows NT (%d+)%.(%d+)")
   if wh and wl then
      local old=true
      wh,wl=tonumber(wh),tonumber(wl)
      if wh >= 6 then
         if wl == 0 then
            os="Windows Vista"
         else
            if  wl == 2 then
               os="Windows 8"
            else
               os="Windows 7"
            end
            old=false
         end
      else
         os="Windows XP"
         old=true
      end
      url=fmt("%stutorials/mapping_windows%s_drive.lsp",url,old and "" or "7")
   elseif ua:find("Macintosh",1,true) then
      url=fmt("%stutorials/WebDAV-Mac-Finder.lsp",url)
      os="Macintosh"
   elseif ua:find("iPhone",1,true) then
      url=fmt("%stutorials/Mobile-WebDAV.lsp?type=iPhone",url)
      os="iPhone"
   elseif ua:find("iPad",1,true) then
      url=fmt("%stutorials/Mobile-WebDAV.lsp?type=iPad",url)
      os="iPad"
   elseif ua:find("Android",1,true) then
      url=fmt("%stutorials/Mobile-WebDAV.lsp?type=Android",url)
      os="Android"
   elseif ua:find("Windows Phone",1,true) then
      url=fmt("%stutorials/Mobile-WebDAV.lsp?type=WindowsPhone",url)
      os="Windows Phone"
   elseif ua:find("Linux",1,true) then
      url=fmt("%stutorials/WebDAV-Linux.lsp",url)
      os="Linux"
   end
   return os,url
end

local os,url=getOS()


function setTypeHeaders(fn)
   response:setheader("Content-type","application/octet-stream")
   response:setheader("Content-Disposition",
                      fmt("attachment; filename=\"%s.cmd\"",
                          fn))
   response:setheader(
                      "Cache-Control",
                      "no-store, no-cache, no-transform, must-revalidate, private")
   response:setheader("Pragma","private")
   response:setheader("Expires","0")
end

local uname = request:user()
if not uname then
   response:senderror(500, "Not auth.")
   return -- Should not be possible as we must be authenticated here
end
local urit,accessRights=ba.openio"vm":loadfile("/.bdlua/wfsacess.lua")(uname)
title="Web-File-Server"
response:include"/rtl/.header.lsp"

local host = request:header"Host"
local isLocal = (host == "localhost" or host == "127.0.0.1") and true or false
?>
<h1>Web File Server</h1>
<h3>(Web-File-Manager and WebDAV links)</h3>

<?lsp
local cmdDisabled=false
if isLocal then
  cmdDisabled = true
?>
<script>
$(function(){
      $("#noremote").click(function(){
            $(this).parent().remove();
            $("#noremoteinfo").fadeIn();
            return false;
      });
});
</script>
<p>You are not accessing your server from a remote computer! <a id="noremote" href="#">What does this mean</a>?</p>
<div id="noremoteinfo" style="display:none;border: solid 1px;border-color:red;margin:1em;padding:1em">
<h3 style="color:red;">You are not accessing your server from a remote computer!</h3>
<p>The domain name "localhost", which is the same as the IP address "127.0.0.1", means that you are accessing your FuguHub server via a browser that is on the same computer as your server.</p>
<p>Use the Web File Server from another computer on your home/office network or when you are out travelling and accessing your home/office computer from a remote computer.  You can still use the Web-File-Manager on this computer if you are new to FuguHub and would like to learn more about how the Web-File-Manager functions.</p>
</div>
<?lsp
end
?>
<table><tr><td>

<p>The Web File Manager and WebDAV provide services similar to file sharing software, thus enabling users to easily upload and download files.</p>



<ol>
<li><p>Access the WebDAV server by using a <a target="_blank" href="https://FuguHub.com/resources.lsp">WebDAV client</a>. A WebDAV client can map/mount the FuguHub WebDAV server as an external drive.</p></li>
<li><p>Access the Web File Manager using a web browser such as Safari, Chrome, Internet Explorer, Firefox, etc.</p></li>
</ol>

</td><td>
<div class="roundedbox bluebox" style="width:300px">
<h2>Connect WebDAV (1):</h2>
<p>You appear to be using <?lsp=os?>. See our <a target="_blank" href="<?lsp=url?>"><?lsp=os?> WebDAV Tutorial</a> for how to connect your <?lsp=os?> as a WebDAV client.</p>
</div>
</td></tr></table>



<p><br/></p>
<p><b>Click one of the links shown in the table below to access the Web File Manager (2):</b></p>

<table cellpadding="5" border="1" style="width:80%;margin-left: auto;margin-right: auto;">
<tr><th class="bluebox">File Server Links</th><th  class="bluebox">Access Rights</th></tr>
<?lsp
   -- We now have a table where the keys are all the URI's the user can access.
   -- The table contains another table with all HTTP methods allowed (currently not used).
   for uri,mt in pairs(urit) do
      uri="/fs/"..uri
      uri = uri:gsub("//","/") -- just in case
      response:write("<tr><td><a href='",uri,"'>",uri == '/' and 'root' or uri,"</a></td><td>",accessRights(mt),"</td></tr>")
   end
?>
</table>
<br/>

<?lsp response:include"/rtl/.footer.lsp" ?>
