<?lsp
local pass
local name = request:user()
if not name then
   response:sendredirect"/"
end

local udb = bd.db.user.load()
local user = udb.v[name]
if user then
   pass = user.pwd
end

if not pass then
   response:senderror(503, "Cannot access user db")
   return
end


local httpPort
local sockPort

-- Tables collected from dynamic FORM data
local lp={} -- Local port
local rh={} -- Remote host
local rp={} -- Remote port
local sessionId

-- Collect tunnel data
if request:method() == "POST" then
   for name,value in request:datapairs() do
      if name == "lp" then table.insert(lp, value)
      elseif name == "rh" then table.insert(rh, value)
      elseif name == "rp" then table.insert(rp, value)
      elseif name == "http" then httpPort=tonumber(value)
      elseif name == "socks" then sockPort=tonumber(value)
      end
   end
   local href=response:encoderedirecturl(request:uri(),true,true)
   sessionId=request:session():id(true)
   response:sendredirect(ba.b64encode(bd.aesencode(ba.json.encode{
      lp=lp,rh=rh,rp=rp,h=httpPort,s=sockPort,id=sessionId}))..".jnlp")
else
   if not params then
      response:sendredirect"/"
   end
   lp=params.lp
   rh=params.rh
   rp=params.rp
   httpPort=params.h
   sockPort=params.s
   sessionId=params.id
end

-- Create JNLP arguments
local jnlpArg={}
if httpPort and httpPort > 0 then
   table.insert(jnlpArg,string.format(
     "<argument>h:localhost:%d</argument>\n",httpPort))
end
if sockPort and sockPort > 0 then
   table.insert(jnlpArg,string.format(
     "<argument>s:localhost:%d</argument>\n",sockPort))
end
if #lp ~= 0 and #lp == #rh and #rh == #rp then
   for i in ipairs(lp) do
      local lpn = tonumber(lp[i])
      local rhn = string.gsub(rh[i], "^%s*(.-)%s*$", "%1")
      local rpn = tonumber(rp[i])
      if lpn and lpn > 0 and #rhn > 0 and rpn and rpn > 0 then
         table.insert(jnlpArg,string.format(
           "<argument>t:localhost:%d:%s:%d</argument>\n",lpn,rhn,rpn))
      end
   end
end

if #jnlpArg == 0 then
   print("<h1>You did not specify any tunnel arguments.</h1>")
   print("<p>Please press the back button and try again.</p>")
   return
end


local codebase=request:url():match"(.-)[^/]+$"

local rspTab={}
local function collect(data)
   table.insert(rspTab, data)
end
local xresp=response:setresponse(collect)

?><jnlp spec="0.2 1.0" codebase="<?lsp=codebase?>">
  <information> 
    <title>HTTPS tunnel</title> 
    <vendor>Real Time Logic LLC.</vendor>
    <homepage href="https://FuguHub.com/"/>
    <description></description>
    <description kind="short">HTTPS tunnel Java Web Start version</description>
    <icon href="<?lsp=response:encoderedirecturl("/rtl/images/logo.gif")?>"/>
    <offline-allowed/> 
  </information> 
  <security>
    <all-permissions/>
  </security>
  <resources>
    <j2se version="1.5+"/>
    <jar href="HttpsTunnelWS.jar" main="true" download="eager"/>
  </resources>
  <application-desc main-class="WebStart">
    <argument>-session</argument>
    <argument><?lsp=sessionId?></argument>
    <argument><?lsp=request:header"Host"?></argument>
    <?lsp=table.concat(jnlpArg)?>
  </application-desc>
  <security>
    <all-permissions/>
  </security> 
</jnlp>
<?lsp
 xresp:finalize()
 response:reset()
 response:setdefaultheaders() 
 response:setcontenttype("application/x-java-jnlp-file")
 local data=table.concat(rspTab)
 response:setcontentlength(#data)
 response:send(data) 
?>
